/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSMediaSourceStates.h"

#include "JSDOMBinding.h"
#include "MediaSourceStates.h"
#include "URL.h"
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsMediaSourceStatesSourceType(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaSourceStatesSourceId(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaSourceStatesWidth(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaSourceStatesHeight(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaSourceStatesFrameRate(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaSourceStatesAspectRatio(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaSourceStatesFacingMode(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMediaSourceStatesVolume(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSMediaSourceStatesPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSMediaSourceStatesPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMediaSourceStatesPrototype* ptr = new (NotNull, JSC::allocateCell<JSMediaSourceStatesPrototype>(vm.heap)) JSMediaSourceStatesPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMediaSourceStatesPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table */

static const struct CompactHashIndex JSMediaSourceStatesTableIndex[16] = {
    { -1, -1 },
    { 5, -1 },
    { -1, -1 },
    { 0, -1 },
    { -1, -1 },
    { -1, -1 },
    { 3, -1 },
    { -1, -1 },
    { -1, -1 },
    { 1, -1 },
    { -1, -1 },
    { -1, -1 },
    { -1, -1 },
    { 4, -1 },
    { 2, -1 },
    { -1, -1 },
};


static const HashTableValue JSMediaSourceStatesTableValues[] =
{
    { "width", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesWidth), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "height", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesHeight), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "frameRate", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesFrameRate), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "aspectRatio", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesAspectRatio), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "facingMode", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesFacingMode), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "volume", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesVolume), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

static const HashTable JSMediaSourceStatesTable = { 6, 15, true, JSMediaSourceStatesTableValues, 0, JSMediaSourceStatesTableIndex };
/* Hash table for prototype */

static const HashTableValue JSMediaSourceStatesPrototypeTableValues[] =
{
    { "sourceType", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesSourceType), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "sourceId", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaSourceStatesSourceId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

const ClassInfo JSMediaSourceStatesPrototype::s_info = { "MediaSourceStatesPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMediaSourceStatesPrototype) };

void JSMediaSourceStatesPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMediaSourceStatesPrototypeTableValues, *this);
}

const ClassInfo JSMediaSourceStates::s_info = { "MediaSourceStates", &Base::s_info, &JSMediaSourceStatesTable, CREATE_METHOD_TABLE(JSMediaSourceStates) };

JSMediaSourceStates::JSMediaSourceStates(Structure* structure, JSDOMGlobalObject* globalObject, Ref<MediaSourceStates>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSMediaSourceStates::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSMediaSourceStatesPrototype::create(vm, globalObject, JSMediaSourceStatesPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSMediaSourceStates::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSMediaSourceStates>(vm, globalObject);
}

void JSMediaSourceStates::destroy(JSC::JSCell* cell)
{
    JSMediaSourceStates* thisObject = static_cast<JSMediaSourceStates*>(cell);
    thisObject->JSMediaSourceStates::~JSMediaSourceStates();
}

JSMediaSourceStates::~JSMediaSourceStates()
{
    releaseImpl();
}

bool JSMediaSourceStates::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    auto* thisObject = jsCast<JSMediaSourceStates*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSMediaSourceStates, Base>(exec, JSMediaSourceStatesTable, thisObject, propertyName, slot);
}

EncodedJSValue jsMediaSourceStatesSourceType(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaSourceStates* castedThis = jsDynamicCast<JSMediaSourceStates*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaSourceStatesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaSourceStates", "sourceType");
        return throwGetterTypeError(*exec, "MediaSourceStates", "sourceType");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.sourceType());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaSourceStatesSourceId(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaSourceStates* castedThis = jsDynamicCast<JSMediaSourceStates*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaSourceStatesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaSourceStates", "sourceId");
        return throwGetterTypeError(*exec, "MediaSourceStates", "sourceId");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.sourceId());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaSourceStatesWidth(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSMediaSourceStates*>(slotBase);
    return JSValue::encode(castedThis->width(exec));
}


EncodedJSValue jsMediaSourceStatesHeight(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSMediaSourceStates*>(slotBase);
    return JSValue::encode(castedThis->height(exec));
}


EncodedJSValue jsMediaSourceStatesFrameRate(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSMediaSourceStates*>(slotBase);
    return JSValue::encode(castedThis->frameRate(exec));
}


EncodedJSValue jsMediaSourceStatesAspectRatio(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSMediaSourceStates*>(slotBase);
    return JSValue::encode(castedThis->aspectRatio(exec));
}


EncodedJSValue jsMediaSourceStatesFacingMode(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSMediaSourceStates*>(slotBase);
    return JSValue::encode(castedThis->facingMode(exec));
}


EncodedJSValue jsMediaSourceStatesVolume(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSMediaSourceStates*>(slotBase);
    return JSValue::encode(castedThis->volume(exec));
}


bool JSMediaSourceStatesOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSMediaSourceStatesOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsMediaSourceStates = jsCast<JSMediaSourceStates*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMediaSourceStates->impl(), jsMediaSourceStates);
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, MediaSourceStates* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSMediaSourceStates>(globalObject, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to MediaSourceStates.
    COMPILE_ASSERT(!__is_polymorphic(MediaSourceStates), MediaSourceStates_is_polymorphic_but_idl_claims_not_to_be);
#endif
    return createNewWrapper<JSMediaSourceStates>(globalObject, impl);
}

MediaSourceStates* JSMediaSourceStates::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSMediaSourceStates*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(MEDIA_STREAM)
