/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMemoryInfo.h"

#include "JSDOMBinding.h"
#include "MemoryInfo.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsMemoryInfoUsedJSHeapSize(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsMemoryInfoTotalJSHeapSize(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSMemoryInfoPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSMemoryInfoPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMemoryInfoPrototype* ptr = new (NotNull, JSC::allocateCell<JSMemoryInfoPrototype>(vm.heap)) JSMemoryInfoPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMemoryInfoPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSMemoryInfoPrototypeTableValues[] =
{
    { "usedJSHeapSize", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMemoryInfoUsedJSHeapSize), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "totalJSHeapSize", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMemoryInfoTotalJSHeapSize), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

const ClassInfo JSMemoryInfoPrototype::s_info = { "MemoryInfoPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMemoryInfoPrototype) };

void JSMemoryInfoPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMemoryInfoPrototypeTableValues, *this);
}

const ClassInfo JSMemoryInfo::s_info = { "MemoryInfo", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMemoryInfo) };

JSMemoryInfo::JSMemoryInfo(Structure* structure, JSDOMGlobalObject* globalObject, Ref<MemoryInfo>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSMemoryInfo::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSMemoryInfoPrototype::create(vm, globalObject, JSMemoryInfoPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSMemoryInfo::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSMemoryInfo>(vm, globalObject);
}

void JSMemoryInfo::destroy(JSC::JSCell* cell)
{
    JSMemoryInfo* thisObject = static_cast<JSMemoryInfo*>(cell);
    thisObject->JSMemoryInfo::~JSMemoryInfo();
}

JSMemoryInfo::~JSMemoryInfo()
{
    releaseImpl();
}

EncodedJSValue jsMemoryInfoUsedJSHeapSize(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMemoryInfo* castedThis = jsDynamicCast<JSMemoryInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMemoryInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MemoryInfo", "usedJSHeapSize");
        return throwGetterTypeError(*exec, "MemoryInfo", "usedJSHeapSize");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.usedJSHeapSize());
    return JSValue::encode(result);
}


EncodedJSValue jsMemoryInfoTotalJSHeapSize(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMemoryInfo* castedThis = jsDynamicCast<JSMemoryInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMemoryInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MemoryInfo", "totalJSHeapSize");
        return throwGetterTypeError(*exec, "MemoryInfo", "totalJSHeapSize");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.totalJSHeapSize());
    return JSValue::encode(result);
}


bool JSMemoryInfoOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSMemoryInfoOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsMemoryInfo = jsCast<JSMemoryInfo*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMemoryInfo->impl(), jsMemoryInfo);
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, MemoryInfo* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSMemoryInfo>(globalObject, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to MemoryInfo.
    COMPILE_ASSERT(!__is_polymorphic(MemoryInfo), MemoryInfo_is_polymorphic_but_idl_claims_not_to_be);
#endif
    return createNewWrapper<JSMemoryInfo>(globalObject, impl);
}

MemoryInfo* JSMemoryInfo::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSMemoryInfo*>(value))
        return &wrapper->impl();
    return nullptr;
}

}
