/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(QUOTA)

#include "JSStorageInfo.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSStorageErrorCallback.h"
#include "JSStorageQuotaCallback.h"
#include "JSStorageUsageCallback.h"
#include "StorageInfo.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsStorageInfoPrototypeFunctionQueryUsageAndQuota(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsStorageInfoPrototypeFunctionRequestQuota(JSC::ExecState*);

class JSStorageInfoPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSStorageInfoPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSStorageInfoPrototype* ptr = new (NotNull, JSC::allocateCell<JSStorageInfoPrototype>(vm.heap)) JSStorageInfoPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSStorageInfoPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSStorageInfoPrototypeTableValues[] =
{
    { "TEMPORARY", DontDelete | ReadOnly | ConstantInteger, NoIntrinsic, (intptr_t)(0), (intptr_t) (0) },
    { "PERSISTENT", DontDelete | ReadOnly | ConstantInteger, NoIntrinsic, (intptr_t)(1), (intptr_t) (0) },
    { "queryUsageAndQuota", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsStorageInfoPrototypeFunctionQueryUsageAndQuota), (intptr_t) (1) },
    { "requestQuota", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsStorageInfoPrototypeFunctionRequestQuota), (intptr_t) (2) },
};

const ClassInfo JSStorageInfoPrototype::s_info = { "StorageInfoPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStorageInfoPrototype) };

void JSStorageInfoPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSStorageInfoPrototypeTableValues, *this);
}

const ClassInfo JSStorageInfo::s_info = { "StorageInfo", &Base::s_info, 0, CREATE_METHOD_TABLE(JSStorageInfo) };

JSStorageInfo::JSStorageInfo(Structure* structure, JSDOMGlobalObject* globalObject, Ref<StorageInfo>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSStorageInfo::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSStorageInfoPrototype::create(vm, globalObject, JSStorageInfoPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSStorageInfo::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSStorageInfo>(vm, globalObject);
}

void JSStorageInfo::destroy(JSC::JSCell* cell)
{
    JSStorageInfo* thisObject = static_cast<JSStorageInfo*>(cell);
    thisObject->JSStorageInfo::~JSStorageInfo();
}

JSStorageInfo::~JSStorageInfo()
{
    releaseImpl();
}

EncodedJSValue JSC_HOST_CALL jsStorageInfoPrototypeFunctionQueryUsageAndQuota(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSStorageInfo* castedThis = jsDynamicCast<JSStorageInfo*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "StorageInfo", "queryUsageAndQuota");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSStorageInfo::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    auto* scriptContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
    if (!scriptContext)
        return JSValue::encode(jsUndefined());
    uint16_t storageType = toUInt16(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    RefPtr<StorageUsageCallback> usageCallback;
    if (!exec->argument(1).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(1).isFunction())
            return throwArgumentMustBeFunctionError(*exec, 1, "usageCallback", "StorageInfo", "queryUsageAndQuota");
        usageCallback = JSStorageUsageCallback::create(asObject(exec->uncheckedArgument(1)), castedThis->globalObject());
    }
    RefPtr<StorageErrorCallback> errorCallback;
    if (!exec->argument(2).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(2).isFunction())
            return throwArgumentMustBeFunctionError(*exec, 2, "errorCallback", "StorageInfo", "queryUsageAndQuota");
        errorCallback = JSStorageErrorCallback::create(asObject(exec->uncheckedArgument(2)), castedThis->globalObject());
    }
    impl.queryUsageAndQuota(scriptContext, storageType, usageCallback, errorCallback);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsStorageInfoPrototypeFunctionRequestQuota(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSStorageInfo* castedThis = jsDynamicCast<JSStorageInfo*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "StorageInfo", "requestQuota");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSStorageInfo::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 2))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    auto* scriptContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
    if (!scriptContext)
        return JSValue::encode(jsUndefined());
    uint16_t storageType = toUInt16(exec, exec->argument(0), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    unsigned long long newQuotaInBytes = toUInt64(exec, exec->argument(1), NormalConversion);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    RefPtr<StorageQuotaCallback> quotaCallback;
    if (!exec->argument(2).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(2).isFunction())
            return throwArgumentMustBeFunctionError(*exec, 2, "quotaCallback", "StorageInfo", "requestQuota");
        quotaCallback = JSStorageQuotaCallback::create(asObject(exec->uncheckedArgument(2)), castedThis->globalObject());
    }
    RefPtr<StorageErrorCallback> errorCallback;
    if (!exec->argument(3).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(3).isFunction())
            return throwArgumentMustBeFunctionError(*exec, 3, "errorCallback", "StorageInfo", "requestQuota");
        errorCallback = JSStorageErrorCallback::create(asObject(exec->uncheckedArgument(3)), castedThis->globalObject());
    }
    impl.requestQuota(scriptContext, storageType, newQuotaInBytes, quotaCallback, errorCallback);
    return JSValue::encode(jsUndefined());
}

bool JSStorageInfoOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSStorageInfoOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsStorageInfo = jsCast<JSStorageInfo*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsStorageInfo->impl(), jsStorageInfo);
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, StorageInfo* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSStorageInfo>(globalObject, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to StorageInfo.
    COMPILE_ASSERT(!__is_polymorphic(StorageInfo), StorageInfo_is_polymorphic_but_idl_claims_not_to_be);
#endif
    return createNewWrapper<JSStorageInfo>(globalObject, impl);
}

StorageInfo* JSStorageInfo::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSStorageInfo*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(QUOTA)
